//
// Atune - Auto-Tuning of Numerical Applications for GPUs.
//
// - Version 1.0 (April 2011)
//
// - Hans Henrik Brandenborg Sørensen, hhs@imm.dtu.dk
// - GPUlab, DTU Informatics
// - Technical University of Denmark
//
#define m_max 1
#define n_max 177827942
#define m_grid 1
#define n_grid 264
#define m_step (log10(m_max)/m_grid)
#define n_step (log10(n_max)/n_grid)
#define m_idx ((int)(log10(m)/m_step))
#define n_idx ((int)(log10(n)/n_step))

int besttable_samax[] = { 
12, 7, 9, 7, 9, 5, 5, 6, 2, 3, 4, 4, 9, 2, 8, 15, 7, 2, 85, 71, 13, 7, 4, 4, 4, 7, 8, 11, 7, 2, 11, 9, 7, 11, 9, 8, 5, 3, 1, 14, 20, 14, 17, 19, 18, 22, 14, 11, 10, 19, 19, 33, 20, 30, 21, 16, 33, 22, 33, 33, 10, 20, 33, 29, 33, 33, 11, 33, 46, 3, 33, 11, 50, 46, 50, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 23, 11, 11, 18, 23, 11, 11, 11, 18, 27, 11, 27, 12, 11, 46, 42, 59, 23, 46, 46, 42, 12, 41, 46, 46, 19, 46, 45, 53, 45, 46, 46, 36, 42, 46, 42, 28, 28, 28, 46, 79, 19, 19, 79, 47, 29, 28, 29, 28, 54, 80, 74, 48, 37, 48, 30, 80, 55, 48, 48, 54, 60, 63, 49, 81, 49, 75, 49, 56, 56, 24, 34, 49, 43, 49, 72, 61, 50, 82, 69, 69, 35, 68, 51, 43, 76, 78, 68, 68, 68, 76, 64, 82, 68, 51, 51, 83, 51, 69, 39, 62, 57, 83, 39, 58, 44, 65, 32, 44, 62, 67, 26, 33, 77, 77, 84, 52, 66, 70, 73, 40, 31, 25, 25, 25, 25, 31, 25, 34, 25, 25, 25, 25, 25, 34, 25, 34, 38, 25, 25, 25, 25, 25, 34, 25, 34, 25, 34, 25, 34, 34, 25, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 38, 
};

int atune_samax(samax_arguments)
{
   int bestkernel = besttable_samax[n_idx];
   switch (bestkernel)
   {
   case 1:
      samax_v1<1, 16, 1, 1>(x_d, y_d, n);
      break;
   case 2:
      samax_v1<1, 16, 1, 2>(x_d, y_d, n);
      break;
   case 3:
      samax_v1<1, 16, 1, 4>(x_d, y_d, n);
      break;
   case 4:
      samax_v1<1, 16, 1, 8>(x_d, y_d, n);
      break;
   case 5:
      samax_v1<1, 16, 1, 16>(x_d, y_d, n);
      break;
   case 6:
      samax_v1<1, 16, 1, 32>(x_d, y_d, n);
      break;
   case 7:
      samax_v1<1, 16, 1, 64>(x_d, y_d, n);
      break;
   case 8:
      samax_v1<1, 16, 1, 128>(x_d, y_d, n);
      break;
   case 9:
      samax_v1<1, 16, 1, 256>(x_d, y_d, n);
      break;
   case 10:
      samax_v1<1, 32, 1, 1>(x_d, y_d, n);
      break;
   case 11:
      samax_v1<1, 32, 1, 2>(x_d, y_d, n);
      break;
   case 12:
      samax_v1<1, 32, 1, 8>(x_d, y_d, n);
      break;
   case 13:
      samax_v1<1, 32, 1, 32>(x_d, y_d, n);
      break;
   case 14:
      samax_v1<1, 32, 1, 64>(x_d, y_d, n);
      break;
   case 15:
      samax_v1<1, 32, 1, 256>(x_d, y_d, n);
      break;
   case 16:
      samax_v1<1, 64, 1, 1>(x_d, y_d, n);
      break;
   case 17:
      samax_v1<1, 64, 1, 2>(x_d, y_d, n);
      break;
   case 18:
      samax_v1<1, 64, 1, 4>(x_d, y_d, n);
      break;
   case 19:
      samax_v1<1, 64, 1, 8>(x_d, y_d, n);
      break;
   case 20:
      samax_v1<1, 64, 1, 32>(x_d, y_d, n);
      break;
   case 21:
      samax_v1<1, 64, 1, 64>(x_d, y_d, n);
      break;
   case 22:
      samax_v1<1, 64, 1, 256>(x_d, y_d, n);
      break;
   case 23:
      samax_v1<1, 96, 1, 2>(x_d, y_d, n);
      break;
   case 24:
      samax_v1<1, 96, 1, 16>(x_d, y_d, n);
      break;
   case 25:
      samax_v1<1, 96, 1, 32>(x_d, y_d, n);
      break;
   case 26:
      samax_v1<1, 96, 1, 256>(x_d, y_d, n);
      break;
   case 27:
      samax_v1<1, 128, 1, 2>(x_d, y_d, n);
      break;
   case 28:
      samax_v1<1, 128, 1, 4>(x_d, y_d, n);
      break;
   case 29:
      samax_v1<1, 128, 1, 8>(x_d, y_d, n);
      break;
   case 30:
      samax_v1<1, 128, 1, 16>(x_d, y_d, n);
      break;
   case 31:
      samax_v1<1, 128, 1, 32>(x_d, y_d, n);
      break;
   case 32:
      samax_v1<1, 128, 1, 128>(x_d, y_d, n);
      break;
   case 33:
      samax_v1<1, 128, 1, 256>(x_d, y_d, n);
      break;
   case 34:
      samax_v1<1, 160, 1, 16>(x_d, y_d, n);
      break;
   case 35:
      samax_v1<1, 160, 1, 32>(x_d, y_d, n);
      break;
   case 36:
      samax_v1<1, 192, 1, 2>(x_d, y_d, n);
      break;
   case 37:
      samax_v1<1, 192, 1, 4>(x_d, y_d, n);
      break;
   case 38:
      samax_v1<1, 192, 1, 16>(x_d, y_d, n);
      break;
   case 39:
      samax_v1<1, 192, 1, 64>(x_d, y_d, n);
      break;
   case 40:
      samax_v1<1, 192, 1, 128>(x_d, y_d, n);
      break;
   case 41:
      samax_v1<1, 224, 1, 1>(x_d, y_d, n);
      break;
   case 42:
      samax_v1<1, 224, 1, 2>(x_d, y_d, n);
      break;
   case 43:
      samax_v1<1, 224, 1, 32>(x_d, y_d, n);
      break;
   case 44:
      samax_v1<1, 224, 1, 64>(x_d, y_d, n);
      break;
   case 45:
      samax_v1<1, 256, 1, 1>(x_d, y_d, n);
      break;
   case 46:
      samax_v1<1, 256, 1, 2>(x_d, y_d, n);
      break;
   case 47:
      samax_v1<1, 256, 1, 4>(x_d, y_d, n);
      break;
   case 48:
      samax_v1<1, 256, 1, 8>(x_d, y_d, n);
      break;
   case 49:
      samax_v1<1, 256, 1, 16>(x_d, y_d, n);
      break;
   case 50:
      samax_v1<1, 256, 1, 32>(x_d, y_d, n);
      break;
   case 51:
      samax_v1<1, 256, 1, 64>(x_d, y_d, n);
      break;
   case 52:
      samax_v1<1, 256, 1, 128>(x_d, y_d, n);
      break;
   case 53:
      samax_v1<1, 288, 1, 2>(x_d, y_d, n);
      break;
   case 54:
      samax_v1<1, 288, 1, 4>(x_d, y_d, n);
      break;
   case 55:
      samax_v1<1, 288, 1, 8>(x_d, y_d, n);
      break;
   case 56:
      samax_v1<1, 288, 1, 16>(x_d, y_d, n);
      break;
   case 57:
      samax_v1<1, 288, 1, 32>(x_d, y_d, n);
      break;
   case 58:
      samax_v1<1, 288, 1, 64>(x_d, y_d, n);
      break;
   case 59:
      samax_v1<1, 320, 1, 2>(x_d, y_d, n);
      break;
   case 60:
      samax_v1<1, 320, 1, 8>(x_d, y_d, n);
      break;
   case 61:
      samax_v1<1, 320, 1, 16>(x_d, y_d, n);
      break;
   case 62:
      samax_v1<1, 320, 1, 64>(x_d, y_d, n);
      break;
   case 63:
      samax_v1<1, 352, 1, 8>(x_d, y_d, n);
      break;
   case 64:
      samax_v1<1, 352, 1, 16>(x_d, y_d, n);
      break;
   case 65:
      samax_v1<1, 352, 1, 64>(x_d, y_d, n);
      break;
   case 66:
      samax_v1<1, 352, 1, 128>(x_d, y_d, n);
      break;
   case 67:
      samax_v1<1, 352, 1, 256>(x_d, y_d, n);
      break;
   case 68:
      samax_v1<1, 384, 1, 16>(x_d, y_d, n);
      break;
   case 69:
      samax_v1<1, 384, 1, 32>(x_d, y_d, n);
      break;
   case 70:
      samax_v1<1, 384, 1, 128>(x_d, y_d, n);
      break;
   case 71:
      samax_v1<1, 416, 1, 1>(x_d, y_d, n);
      break;
   case 72:
      samax_v1<1, 416, 1, 16>(x_d, y_d, n);
      break;
   case 73:
      samax_v1<1, 416, 1, 128>(x_d, y_d, n);
      break;
   case 74:
      samax_v1<1, 448, 1, 4>(x_d, y_d, n);
      break;
   case 75:
      samax_v1<1, 448, 1, 8>(x_d, y_d, n);
      break;
   case 76:
      samax_v1<1, 448, 1, 16>(x_d, y_d, n);
      break;
   case 77:
      samax_v1<1, 448, 1, 128>(x_d, y_d, n);
      break;
   case 78:
      samax_v1<1, 480, 1, 16>(x_d, y_d, n);
      break;
   case 79:
      samax_v1<1, 512, 1, 2>(x_d, y_d, n);
      break;
   case 80:
      samax_v1<1, 512, 1, 4>(x_d, y_d, n);
      break;
   case 81:
      samax_v1<1, 512, 1, 8>(x_d, y_d, n);
      break;
   case 82:
      samax_v1<1, 512, 1, 16>(x_d, y_d, n);
      break;
   case 83:
      samax_v1<1, 512, 1, 32>(x_d, y_d, n);
      break;
   case 84:
      samax_v1<1, 512, 1, 128>(x_d, y_d, n);
      break;
   case 85:
      samax_v1<1, 1024, 1, 128>(x_d, y_d, n);
      break;
   default:
      printf("\nsamax.h : bestkernelSwitch : problem size not supported (n = %d, bestkernel = %d).\n", n, bestkernel);
      exit(EXIT_FAILURE);
   }
   return bestkernel;
}
