//
// Atune - Auto-Tuning of Numerical Applications for GPUs.
//
// - Version 1.0 (April 2011)
//
// - Hans Henrik Brandenborg Sørensen, hhs@imm.dtu.dk
// - GPUlab, DTU Informatics
// - Technical University of Denmark
//
#define m_max 1
#define n_max 177827942
#define m_grid 1
#define n_grid 264
#define m_step (log10(m_max)/m_grid)
#define n_step (log10(n_max)/n_grid)
#define m_idx ((int)(log10(m)/m_step))
#define n_idx ((int)(log10(n)/n_step))

int besttable_snrm2[] = { 
9, 8, 14, 17, 9, 6, 15, 4, 7, 1, 16, 17, 6, 5, 17, 2, 5, 48, 10, 23, 10, 25, 13, 7, 13, 8, 3, 13, 3, 12, 3, 9, 3, 7, 9, 3, 7, 6, 5, 9, 33, 7, 17, 1, 4, 9, 13, 9, 2, 1, 2, 34, 10, 2, 1, 2, 1, 1, 1, 5, 2, 1, 3, 1, 2, 1, 3, 10, 4, 10, 10, 2, 2, 10, 2, 2, 1, 3, 10, 2, 3, 2, 10, 3, 10, 2, 10, 12, 2, 2, 19, 3, 12, 3, 12, 4, 4, 18, 4, 19, 11, 19, 3, 11, 4, 4, 13, 4, 12, 20, 26, 20, 27, 28, 20, 20, 20, 27, 20, 35, 20, 29, 47, 27, 47, 36, 48, 62, 41, 48, 20, 21, 28, 21, 56, 22, 21, 37, 57, 57, 29, 37, 29, 29, 42, 63, 53, 49, 42, 30, 49, 42, 29, 30, 54, 30, 54, 30, 30, 43, 43, 43, 43, 44, 60, 50, 43, 51, 51, 31, 60, 70, 50, 50, 31, 31, 65, 32, 58, 69, 61, 44, 38, 25, 33, 46, 32, 61, 33, 55, 39, 45, 66, 52, 68, 68, 68, 40, 31, 25, 64, 59, 67, 31, 24, 25, 31, 31, 31, 31, 32, 31, 31, 31, 25, 31, 31, 31, 31, 38, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 
};

int atune_snrm2(snrm2_arguments)
{
   int bestkernel = besttable_snrm2[n_idx];
   switch (bestkernel)
   {
   case 1:
      snrm2_v1<1, 16, 1, 1>(x_d, y_d, n);
      break;
   case 2:
      snrm2_v1<1, 16, 1, 2>(x_d, y_d, n);
      break;
   case 3:
      snrm2_v1<1, 16, 1, 4>(x_d, y_d, n);
      break;
   case 4:
      snrm2_v1<1, 16, 1, 8>(x_d, y_d, n);
      break;
   case 5:
      snrm2_v1<1, 16, 1, 16>(x_d, y_d, n);
      break;
   case 6:
      snrm2_v1<1, 16, 1, 32>(x_d, y_d, n);
      break;
   case 7:
      snrm2_v1<1, 16, 1, 64>(x_d, y_d, n);
      break;
   case 8:
      snrm2_v1<1, 16, 1, 128>(x_d, y_d, n);
      break;
   case 9:
      snrm2_v1<1, 16, 1, 256>(x_d, y_d, n);
      break;
   case 10:
      snrm2_v1<1, 32, 1, 1>(x_d, y_d, n);
      break;
   case 11:
      snrm2_v1<1, 32, 1, 2>(x_d, y_d, n);
      break;
   case 12:
      snrm2_v1<1, 32, 1, 4>(x_d, y_d, n);
      break;
   case 13:
      snrm2_v1<1, 32, 1, 8>(x_d, y_d, n);
      break;
   case 14:
      snrm2_v1<1, 32, 1, 16>(x_d, y_d, n);
      break;
   case 15:
      snrm2_v1<1, 32, 1, 64>(x_d, y_d, n);
      break;
   case 16:
      snrm2_v1<1, 32, 1, 128>(x_d, y_d, n);
      break;
   case 17:
      snrm2_v1<1, 32, 1, 256>(x_d, y_d, n);
      break;
   case 18:
      snrm2_v1<1, 64, 1, 1>(x_d, y_d, n);
      break;
   case 19:
      snrm2_v1<1, 64, 1, 2>(x_d, y_d, n);
      break;
   case 20:
      snrm2_v1<1, 64, 1, 4>(x_d, y_d, n);
      break;
   case 21:
      snrm2_v1<1, 64, 1, 8>(x_d, y_d, n);
      break;
   case 22:
      snrm2_v1<1, 64, 1, 16>(x_d, y_d, n);
      break;
   case 23:
      snrm2_v1<1, 64, 1, 32>(x_d, y_d, n);
      break;
   case 24:
      snrm2_v1<1, 64, 1, 64>(x_d, y_d, n);
      break;
   case 25:
      snrm2_v1<1, 64, 1, 128>(x_d, y_d, n);
      break;
   case 26:
      snrm2_v1<1, 96, 1, 1>(x_d, y_d, n);
      break;
   case 27:
      snrm2_v1<1, 96, 1, 2>(x_d, y_d, n);
      break;
   case 28:
      snrm2_v1<1, 96, 1, 4>(x_d, y_d, n);
      break;
   case 29:
      snrm2_v1<1, 96, 1, 8>(x_d, y_d, n);
      break;
   case 30:
      snrm2_v1<1, 96, 1, 16>(x_d, y_d, n);
      break;
   case 31:
      snrm2_v1<1, 96, 1, 32>(x_d, y_d, n);
      break;
   case 32:
      snrm2_v1<1, 96, 1, 64>(x_d, y_d, n);
      break;
   case 33:
      snrm2_v1<1, 96, 1, 128>(x_d, y_d, n);
      break;
   case 34:
      snrm2_v1<1, 96, 1, 256>(x_d, y_d, n);
      break;
   case 35:
      snrm2_v1<1, 128, 1, 2>(x_d, y_d, n);
      break;
   case 36:
      snrm2_v1<1, 128, 1, 4>(x_d, y_d, n);
      break;
   case 37:
      snrm2_v1<1, 128, 1, 8>(x_d, y_d, n);
      break;
   case 38:
      snrm2_v1<1, 128, 1, 32>(x_d, y_d, n);
      break;
   case 39:
      snrm2_v1<1, 128, 1, 64>(x_d, y_d, n);
      break;
   case 40:
      snrm2_v1<1, 128, 1, 256>(x_d, y_d, n);
      break;
   case 41:
      snrm2_v1<1, 160, 1, 2>(x_d, y_d, n);
      break;
   case 42:
      snrm2_v1<1, 160, 1, 8>(x_d, y_d, n);
      break;
   case 43:
      snrm2_v1<1, 160, 1, 16>(x_d, y_d, n);
      break;
   case 44:
      snrm2_v1<1, 160, 1, 32>(x_d, y_d, n);
      break;
   case 45:
      snrm2_v1<1, 160, 1, 64>(x_d, y_d, n);
      break;
   case 46:
      snrm2_v1<1, 160, 1, 128>(x_d, y_d, n);
      break;
   case 47:
      snrm2_v1<1, 192, 1, 1>(x_d, y_d, n);
      break;
   case 48:
      snrm2_v1<1, 192, 1, 2>(x_d, y_d, n);
      break;
   case 49:
      snrm2_v1<1, 192, 1, 8>(x_d, y_d, n);
      break;
   case 50:
      snrm2_v1<1, 192, 1, 16>(x_d, y_d, n);
      break;
   case 51:
      snrm2_v1<1, 192, 1, 32>(x_d, y_d, n);
      break;
   case 52:
      snrm2_v1<1, 192, 1, 64>(x_d, y_d, n);
      break;
   case 53:
      snrm2_v1<1, 224, 1, 4>(x_d, y_d, n);
      break;
   case 54:
      snrm2_v1<1, 224, 1, 8>(x_d, y_d, n);
      break;
   case 55:
      snrm2_v1<1, 224, 1, 64>(x_d, y_d, n);
      break;
   case 56:
      snrm2_v1<1, 256, 1, 2>(x_d, y_d, n);
      break;
   case 57:
      snrm2_v1<1, 256, 1, 4>(x_d, y_d, n);
      break;
   case 58:
      snrm2_v1<1, 256, 1, 32>(x_d, y_d, n);
      break;
   case 59:
      snrm2_v1<1, 256, 1, 128>(x_d, y_d, n);
      break;
   case 60:
      snrm2_v1<1, 288, 1, 16>(x_d, y_d, n);
      break;
   case 61:
      snrm2_v1<1, 288, 1, 32>(x_d, y_d, n);
      break;
   case 62:
      snrm2_v1<1, 320, 1, 1>(x_d, y_d, n);
      break;
   case 63:
      snrm2_v1<1, 320, 1, 4>(x_d, y_d, n);
      break;
   case 64:
      snrm2_v1<1, 320, 1, 128>(x_d, y_d, n);
      break;
   case 65:
      snrm2_v1<1, 352, 1, 32>(x_d, y_d, n);
      break;
   case 66:
      snrm2_v1<1, 352, 1, 64>(x_d, y_d, n);
      break;
   case 67:
      snrm2_v1<1, 352, 1, 128>(x_d, y_d, n);
      break;
   case 68:
      snrm2_v1<1, 352, 1, 256>(x_d, y_d, n);
      break;
   case 69:
      snrm2_v1<1, 416, 1, 32>(x_d, y_d, n);
      break;
   case 70:
      snrm2_v1<1, 480, 1, 16>(x_d, y_d, n);
      break;
   default:
      printf("\nsnrm2.h : bestkernelSwitch : problem size not supported (n = %d, bestkernel = %d).\n", n, bestkernel);
      exit(EXIT_FAILURE);
   }
   return bestkernel;
}
