//
// Atune - Auto-Tuning of Numerical Applications for GPUs.
//
// - Version 1.0 (April 2011)
//
// - Hans Henrik Brandenborg Sørensen, hhs@imm.dtu.dk
// - GPUlab, DTU Informatics
// - Technical University of Denmark
//
#define m_max 1
#define n_max 177827942
#define m_grid 1
#define n_grid 264
#define m_step (log10(m_max)/m_grid)
#define n_step (log10(n_max)/n_grid)
#define m_idx ((int)(log10(m)/m_step))
#define n_idx ((int)(log10(n)/n_step))

int besttable_sread[] = { 
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 32, 25, 42, 45, 54, 10, 50, 4, 25, 13, 46, 46, 37, 37, 48, 40, 15, 36, 44, 46, 46, 42, 54, 40, 40, 40, 54, 39, 37, 9, 40, 54, 15, 49, 40, 36, 15, 54, 13, 38, 2, 37, 37, 43, 25, 55, 39, 24, 54, 47, 37, 37, 54, 36, 1, 1, 48, 4, 42, 3, 12, 23, 23, 48, 12, 2, 22, 13, 8, 12, 14, 47, 42, 48, 7, 12, 13, 42, 42, 7, 51, 3, 42, 42, 42, 44, 37, 22, 2, 12, 22, 48, 5, 22, 23, 23, 7, 13, 12, 45, 12, 12, 47, 51, 47, 13, 54, 9, 22, 14, 13, 13, 37, 22, 14, 13, 24, 6, 15, 52, 39, 14, 23, 53, 15, 26, 38, 10, 11, 17, 24, 20, 55, 24, 27, 35, 35, 29, 27, 33, 18, 35, 16, 41, 28, 40, 18, 30, 31, 57, 21, 56, 31, 38, 38, 49, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 49, 38, 38, 38, 38, 49, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 34, 38, 38, 38, 38, 38, 34, 11, 38, 38, 38, 38, 38, 38, 38, 11, 38, 11, 11, 11, 11, 38, 11, 11, 11, 11, 11, 11, 11, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 18, 18, 18, 19, 
};

int atune_sread(sread_arguments)
{
   int bestkernel = besttable_sread[n_idx];
   switch (bestkernel)
   {
   case 1:
      sread_v1<1, 16, 1, 1>(x_d, n);
      break;
   case 2:
      sread_v1<1, 16, 1, 2>(x_d, n);
      break;
   case 3:
      sread_v1<1, 16, 1, 4>(x_d, n);
      break;
   case 4:
      sread_v1<1, 32, 1, 1>(x_d, n);
      break;
   case 5:
      sread_v1<1, 32, 1, 4>(x_d, n);
      break;
   case 6:
      sread_v1<1, 32, 1, 8>(x_d, n);
      break;
   case 7:
      sread_v1<1, 64, 1, 1>(x_d, n);
      break;
   case 8:
      sread_v1<1, 64, 1, 2>(x_d, n);
      break;
   case 9:
      sread_v1<1, 64, 1, 4>(x_d, n);
      break;
   case 10:
      sread_v1<1, 64, 1, 16>(x_d, n);
      break;
   case 11:
      sread_v1<1, 96, 1, 8>(x_d, n);
      break;
   case 12:
      sread_v1<1, 128, 1, 1>(x_d, n);
      break;
   case 13:
      sread_v1<1, 128, 1, 2>(x_d, n);
      break;
   case 14:
      sread_v1<1, 128, 1, 4>(x_d, n);
      break;
   case 15:
      sread_v1<1, 128, 1, 8>(x_d, n);
      break;
   case 16:
      sread_v1<1, 128, 1, 16>(x_d, n);
      break;
   case 17:
      sread_v1<1, 160, 1, 4>(x_d, n);
      break;
   case 18:
      sread_v1<1, 160, 1, 16>(x_d, n);
      break;
   case 19:
      sread_v1<1, 192, 1, 16>(x_d, n);
      break;
   case 20:
      sread_v1<1, 224, 1, 4>(x_d, n);
      break;
   case 21:
      sread_v1<1, 224, 1, 16>(x_d, n);
      break;
   case 22:
      sread_v1<1, 256, 1, 1>(x_d, n);
      break;
   case 23:
      sread_v1<1, 256, 1, 2>(x_d, n);
      break;
   case 24:
      sread_v1<1, 256, 1, 4>(x_d, n);
      break;
   case 25:
      sread_v1<1, 256, 1, 8>(x_d, n);
      break;
   case 26:
      sread_v1<1, 256, 1, 16>(x_d, n);
      break;
   case 27:
      sread_v1<1, 288, 1, 8>(x_d, n);
      break;
   case 28:
      sread_v1<1, 288, 1, 16>(x_d, n);
      break;
   case 29:
      sread_v1<1, 352, 1, 8>(x_d, n);
      break;
   case 30:
      sread_v1<1, 352, 1, 16>(x_d, n);
      break;
   case 31:
      sread_v1<1, 384, 1, 16>(x_d, n);
      break;
   case 32:
      sread_v1<1, 416, 1, 4>(x_d, n);
      break;
   case 33:
      sread_v1<1, 448, 1, 8>(x_d, n);
      break;
   case 34:
      sread_v1<1, 480, 1, 4>(x_d, n);
      break;
   case 35:
      sread_v1<1, 480, 1, 8>(x_d, n);
      break;
   case 36:
      sread_v1<1, 512, 1, 1>(x_d, n);
      break;
   case 37:
      sread_v1<1, 512, 1, 2>(x_d, n);
      break;
   case 38:
      sread_v1<1, 512, 1, 4>(x_d, n);
      break;
   case 39:
      sread_v1<1, 512, 1, 8>(x_d, n);
      break;
   case 40:
      sread_v1<1, 512, 1, 16>(x_d, n);
      break;
   case 41:
      sread_v1<1, 1024, 1, 16>(x_d, n);
      break;
   case 42:
      sread_v2<1, 16, 1, 2>(x_d, n);
      break;
   case 43:
      sread_v2<1, 16, 1, 8>(x_d, n);
      break;
   case 44:
      sread_v2<1, 32, 1, 2>(x_d, n);
      break;
   case 45:
      sread_v2<1, 32, 1, 4>(x_d, n);
      break;
   case 46:
      sread_v2<1, 32, 1, 16>(x_d, n);
      break;
   case 47:
      sread_v2<1, 64, 1, 2>(x_d, n);
      break;
   case 48:
      sread_v2<1, 64, 1, 4>(x_d, n);
      break;
   case 49:
      sread_v2<1, 64, 1, 8>(x_d, n);
      break;
   case 50:
      sread_v2<1, 128, 1, 2>(x_d, n);
      break;
   case 51:
      sread_v2<1, 128, 1, 4>(x_d, n);
      break;
   case 52:
      sread_v2<1, 128, 1, 8>(x_d, n);
      break;
   case 53:
      sread_v2<1, 192, 1, 8>(x_d, n);
      break;
   case 54:
      sread_v2<1, 256, 1, 2>(x_d, n);
      break;
   case 55:
      sread_v2<1, 256, 1, 8>(x_d, n);
      break;
   case 56:
      sread_v2<1, 352, 1, 16>(x_d, n);
      break;
   case 57:
      sread_v2<1, 416, 1, 16>(x_d, n);
      break;
   default:
      printf("\nsread.h : bestkernelSwitch : problem size not supported (n = %d, bestkernel = %d).\n", n, bestkernel);
      exit(EXIT_FAILURE);
   }
   return bestkernel;
}
